﻿/*!
e-dom wtyczka do jQuery
e-dom jQuery plugin
ver 2.0

Nie jest to najlepszy ani pewnie w 100% poprawy sposób by kontrolować PLC, ale działa :)  Używajcie na własne ryzyko i prywatne potrzeby
This is not the best nor 100% correct way to control a PLC, but it works :)  Use for your private needs and at your own risk

Copyright (c) 2011-2012, e-dom. 

dodatkowe informacje na: 
more info at:

www.edom-plc.pl
 
This code is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 3 as published by
the Free Software Foundation; 

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

If you have not received a copy of the GNU General Public License
along with this code, write to  Free Software Foundation, Inc., 59 Temple
Place, Fifth Floor, Boston, MA  02110-1301  USA or see <http://www.gnu.org/licenses/>.

Niniejszy kod jest wolnym oprogramowaniem; możesz go
rozprowadzać dalej i/lub modyfikować na warunkach Powszechnej
Licencji Publicznej GNU w wersji 3, wydanej przez Fundację Wolnego
Oprogramowania.

Niniejszy kod rozpowszechniany jest z nadzieją, iż będzie on
użyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domyślnej
gwarancji PRZYDATNOŚCI HANDLOWEJ albo PRZYDATNOŚCI DO OKREŚLONYCH
ZASTOSOWAŃ. W celu uzyskania bliższych informacji sięgnij do
Powszechnej Licencji Publicznej GNU.

Jeśli wraz z niniejszym kodem nie otrzymałeś egzemlparza
Powszechnej Licencji Publicznej GNU (GNU General Public License);
napisz do Free Software Foundation, Inc., 59 Temple
Place, Fifth Floor, Boston, MA  02110-1301  USA lub uzyskaj ją pod <http://www.gnu.org/licenses/>.
 */
 
 (function( $ ){
	$.extend({
		StartRefreshing: function(options) {
			var options = $.extend({
				refreshrate: 5000,
			}, options);
			$.RefreshData();
			window.Repeater= window.setInterval('$.RefreshData()',options.refreshrate);
		},
		
		StopRefreshing: function() {
			window.clearInterval(window.Repeater);	
		},		
		
		RefreshData: function() {
			$("[data-refresh=true]").each(function(){
				$(this).RefreshIt();
			});
		}

	});
	
	$.fn.AddButtonCover = function(options) {
		var options = $.extend({
			addimage: 	true,
			imagefile:	'css/loading.gif'
		}, options);
		
		var CurrentButton = $(this);
		
		var CurrentCover = $('<div>', {id: CurrentButton.attr('id')+'_Cover'}).appendTo(CurrentButton);
		CurrentCover.addClass('ButtonCover');
		CurrentCover.css({
				'height': CurrentButton.height(),
				'zIndex': 9999
		});
		
		if (options.addimage) {
			var CurrentImage = $('<img>', {src: options.imagefile}).appendTo(CurrentCover);
			CurrentImage.addClass('CoverImage');
			CurrentImage.load(function(){
				$(this).css({
					marginTop:	-Math.round(this.height/2), 
					marginLeft:	-Math.round(this.width/2) 
				});
			});			
			CurrentButton.data('ButtonCover', CurrentCover);	
		}	
	};  //End of AddButtonCover function

	$.fn.ShowButtonCover = function(options) {
		var options	= $.extend({
			coverdelay: 500
		}, options);
		var CurrentButton = $(this);
		if (CurrentButton.data('ButtonCover')){ 
			var ButtonCoverTimeout = setTimeout('$("#'+CurrentButton.attr('id')+'").data("ButtonCover").show()', options.coverdelay);
			if (CurrentButton.is('div')&&CurrentButton.hasClass('ui-slider')) {
				CurrentButton.slider("disable");
			}
			CurrentButton.data('ButtonCoverTimeout', ButtonCoverTimeout);				
		}; //End IF (ButtonCover exists)	
	}; //End of ShowButtonCover() function
	
	$.fn.HideButtonCover = function() {
		var CurrentButton = $(this);
		if (CurrentButton.data('ButtonCoverTimeout')) {
			clearTimeout(CurrentButton.data('ButtonCoverTimeout'));
		}
		if (CurrentButton.data('ButtonCover')){
			if (CurrentButton.data('ButtonCover').css('display') == 'block') {
				CurrentButton.data('ButtonCover').hide();
			}
			if (CurrentButton.is('div')&&CurrentButton.hasClass('ui-slider')) {
				CurrentButton.slider("enable");
			}			
		}	
	}; //End of HideButtonCover() function
	
	$.fn.WriteValue = function(options) {
		var CurrentButton=$(this);
		if ((options.address===undefined)||(options.value==undefined)){
			var ErrorMessage='Error at '+CurrentButton.attr('id')+', function WriteValue():';
			var MissingParameters=true;		
			if (options.address===undefined){ErrorMessage+='\nMissing Write Address'}
			if (options.value===undefined){ErrorMessage+='\nMissing Value'}
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {	
			var options	= $.extend({
				terminateprevious:	true,
				format: "%d",
			}, options);

			if (CurrentButton.data('WriteAjax')!=null){
				if ((CurrentButton.data('WriteAjax').readyState>0) && (CurrentButton.data('WriteAjax').readyState<4)){
					if (options.terminateprevious) {
						CurrentButton.data('WriteAjax').abort();
					}
					else {
						var WritePending=true;
					};	
				};
			};  //End of IF (another Ajax pending)
			if (!WritePending) {
				var AjaxObj = $.ajax({
					type: 'POST',
					url: ServerName+"WRITEPI",
					data: {ADR1: options.address, VALUE1: options.value, FORMAT1: options.format},
					ajaxParent: CurrentButton,
					successfn: options.successfn,
					success: function(data){
						if (this.successfn!=undefined) {this.successfn.call()}
						else if ($.data( this.ajaxParent.get(0), 'events' ).OnWriteSuccess){
							this.ajaxParent.trigger('OnWriteSuccess',[data]);
						}
					}		
				});
				$(this).data('WriteAjax',AjaxObj);				
			};//End of IF (Write is pending)
		}; //End of IF (Missing parameters)
	}; //End of WriteValue() function
	
	$.fn.ReadValue = function(options) {
		var CurrentField=$(this);
		if (!options.address){
			var ErrorMessage='Error at '+CurrentField.attr('id')+', function ReadValue():\nMissing Read Address';
			var MissingParameters=true;			
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {		
			var options	= $.extend({
				terminateprevious:	true,
				terminatependingwrite: false,
				timeout: 5000,
				format: "%d"
			}, options);
		
			if (CurrentField.data('WriteAjax')!=null){
				if ((CurrentField.data('WriteAjax').readyState>0) && (CurrentField.data('WriteAjax').readyState<4)){
					if (options.terminatependingwrite) {CurrentField.data('WriteAjax').abort();}
					else {var WritePending=true};	
				}
			}
			if (CurrentField.data('ReadAjax')!=null){
				if ((CurrentField.data('ReadAjax').readyState>0) && (CurrentField.data('ReadAjax').readyState<4)){
					if (options.terminateprevious) {CurrentField.data('ReadAjax').abort()}
					else {var ReadPending=true}
				}
			};
			if (!WritePending && !ReadPending){
				var AjaxObj = $.ajax({
					type: 'POST',
					url: ServerName+"READPI",
					data: {ADR: options.address, FORMAT: options.format},
					timeout: options.timeout,					
					ajaxParent: CurrentField,
					successfn: options.successfn,
					success: function(data){
						if (this.successfn!=undefined) {this.successfn.call()}
						else if ($.data( this.ajaxParent.get(0), 'events' ).OnReadSuccess){					
							this.ajaxParent.trigger('OnReadSuccess',[data]);
						}
					}
				});
				CurrentField.data('ReadAjax',AjaxObj);
			};		
		}// End of IF (missing parameters)
	} //End of ReadValue() function
	
	$.fn.MakeReadField = function(options) {
		var CurrentField = $(this);	
		
		if (!options.read){
			var ErrorMessage='Error at '+CurrentField.attr('id')+', function MakeReadField():\nMissing Read Address';
			var MissingParameters=true;			
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {
			var options = $.extend({
				refresh: 		true,
				initstatus:		0,
				refreshtype:	'value',
				valuetype:		'text'
			}, options);
	
			CurrentField.attr('data-read', options.read);			
			CurrentField.attr('data-refresh', options.refresh);
			if (options.readtimeout) {CurrentField.attr('data-readtimeout', options.readtimeout)};
			CurrentField.attr('data-refreshtype', options.refreshtype);
			CurrentField.attr('data-valuetype', options.valuetype);
			
			if (options.image) {CurrentField.data('ImageToFlip', $('#'+options.image))};
			CurrentField.data('Status', options.initstatus);
			
			if (CurrentField.attr('data-refreshtype')==='status') {
				CurrentField.bind('OnReadSuccess', function(event, data){
					var CurrentField = $(this)
					if (CurrentField.data('Status')!= data) { 
						CurrentField.FlipIt();
					}
					return false;
				})
			}			
			if (CurrentField.attr('data-refreshtype')==='slider') {
				CurrentField.bind('OnReadSuccess', function(event, data){
					$(this).slider( "option", "value", parseInt(data))
					return false;
				})
			}
			if (CurrentField.attr('data-refreshtype')==='value') {
				if (CurrentField.attr('data-valuetype')==='temp') {
					CurrentField.bind('OnReadSuccess', function(event, data){					
						if (data>32768) {data-=65536;};
						CurrentField.html('<p>'+(data/10)+'&#176;C</p>');
						return false;						
					})	
				}
				if (CurrentField.attr('data-valuetype')==='text') {
					CurrentField.bind('OnReadSuccess', function(event, data){
						CurrentField.html('<p>'+data+'</p>');
						return false;
					})
				}	
			}
		} //End IF (Missing address)
	};// End of MakeReadField
	
	$.fn.MakeWriteButton = function(options) {
		var CurrentButton=$(this);	

		if ((!options.write)||((options.staticvalue===undefined) && (options.dynamicvalue===undefined))) {
			var ErrorMessage='Error at '+CurrentButton.attr('id')+', function MakeWriteButton():';
			var MissingParameters=true;			
			if (!options.write) {ErrorMessage+='\nMissing Write Address'}
			if ((options.staticvalue===undefined) && (options.dynamicvalue===undefined)) {ErrorMessage+='\nMissing proper Value'}
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {
			CurrentButton.AddButtonCover();
			CurrentButton.attr('data-write', options.write);					
			if (options.coverdelay) {CurrentButton.attr('data-coverdelay', options.coverdelay)};
			if (options.staticvalue!=undefined){
				CurrentButton.attr('data-value', options.staticvalue);
			}
			else {
				CurrentButton.data('ValueHolder', $('#'+options.dynamicvalue));
			}
			if (options.refreshonwrite!=undefined) {
				CurrentButton.data('RefreshOnWrite', $('#'+options.refreshonwrite));
			}
			
			CurrentButton.click(function(){
				var CurrentButton = $(this);
				if (CurrentButton.attr('data-value')!=undefined) {
					var ValueToWrite = CurrentButton.attr('data-value');
				}
				else if (CurrentButton.data('ValueHolder')!=undefined) {
					var ValueHolder=CurrentButton.data('ValueHolder');
					if (ValueHolder.is('div')) {
						if (ValueHolder.hasClass('ui-slider')){var ValueToWrite=ValueHolder.slider( "option", "value" )}
						else {var ValueToWrite = ValueHolder.text()}
					}
					if (ValueHolder.is('input')) {var ValueToWrite = ValueHolder.val()}
				};
				if (ValueToWrite!=undefined){
					CurrentButton.ShowButtonCover();
					CurrentButton.WriteValue({
						address: CurrentButton.attr('data-write'),
						value: ValueToWrite,
					});
				};	
				return false;
			}); //End of Click functions
			
			CurrentButton.bind('OnWriteSuccess', function(){
				var CurrentButton=$(this);
				CurrentButton.HideButtonCover();
				if (CurrentButton.data('RefreshOnWrite')) {
					CurrentButton.data('RefreshOnWrite').RefreshIt();
				}
				return false;
			});
			
		}; // End of IF (Missing parameters)
	}; //End of MakeWriteButton function
	
	$.fn.MakeTapButton = function(options) {
		var CurrentButton=$(this);
		
		if ((options.write===undefined)||(options.read===undefined)) {
			ErrorMessage='Error at '+CurrentButton.attr('id')+', function MakeTapButton():';
			if (options.write===undefined) {ErrorMessage+='\nMissing Write Address'}
			if (options.read===undefined) {ErrorMessage+='\nMissing Read Address'}
			var MissingParameters=true;
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {
			var options = $.extend({
				refresh: 		true,
				initstatus:		0,
				tapduration:	0
			}, options);
			
			CurrentButton.AddButtonCover();
			
			CurrentButton.attr('data-write', options.write);		
			CurrentButton.attr('data-refresh', options.refresh);
			CurrentButton.attr('data-read', options.read);				
			if (options.coverdelay!=undefined) {CurrentButton.attr('data-coverdelay', options.coverdelay)}
			if (options.readtimeout!=undefined) {CurrentButton.attr('data-readtimeout', options.readtimeout)}
			CurrentButton.attr('data-tapduration', options.tapduration);
		
			if (options.image != undefined) {CurrentButton.data('ImageToFlip', $('#'+options.image))}
			CurrentButton.data('Status', options.initstatus);
			
			CurrentButton.click(function(){
				CurrentButton=$(this);
				CurrentButton.ShowButtonCover();				
				CurrentButton.WriteValue({
					address: CurrentButton.attr('data-write'),
					value: 1
				});
			});
			
			CurrentButton.bind('OnWriteSuccess',function(event, data){
				CurrentButton=$(this);
				setTimeout('$("#'+CurrentButton.attr('id')+'").WriteValue({address: "'+CurrentButton.attr('data-write')+'", value: 0, successfn: function(){$("#'+CurrentButton.attr('id')+'").HideButtonCover()}})',(CurrentButton.data('Status')==0)?CurrentButton.attr('data-tapduration'):0);
				CurrentButton.FlipIt();
				return false;
			});
			
			CurrentButton.bind('OnReadSuccess', function(event, data){
				var CurrentField = $(this);					
				if (CurrentField.data('Status')!= data) { 
					CurrentField.FlipIt();
				}
				return false;
			});			
		} //End if (missing parameters)
	};  //End of MakeAjaxButton function
	
	$.fn.RefreshIt = function() {  
		var CurrentField=$(this);
		var ReadParameters = {address: CurrentField.attr('data-read')};
		if (CurrentField.attr('data-readtimeout')!=undefined) {ReadParameters=$.extend({timeout: CurrentField.attr('data-readtimeout')}, ReadParameters)};
		CurrentField.ReadValue(ReadParameters);
	};  //End of RefreshIt function
	
	$.fn.FlipIt = function() {  
		$(this).data('Status', Math.abs($(this).data('Status')-1));
		if ($(this).data('ImageToFlip')) {
			var ImageName=$(this).data('ImageToFlip').attr('src');
			var ImageExtension=ImageName.substring(ImageName.length-4);
			ImageName=ImageName.substring(0,ImageName.length-5);
			$(this).data('ImageToFlip').attr('src',ImageName+$(this).data('Status')+ImageExtension);
		}	
		($(this).data('Status')==0) ?	$(this).removeClass('flipped'):$(this).addClass('flipped');	
	};  //End of FlipIt function
	
})( jQuery );